Package org.apache.commons.compress.compressors.snappy

# Class FramedSnappyCompressorInputStream

java.lang.Object
java.io.InputStream
org.apache.commons.compress.compressors.CompressorInputStream
org.apache.commons.compress.compressors.snappy.FramedSnappyCompressorInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `InputStreamStatistics`

public class FramedSnappyCompressorInputStream extends CompressorInputStream implements InputStreamStatistics
CompressorInputStream for the framing Snappy format.

Based on the "spec" in the version "Last revised: 2013-10-25"

Since:
  1.7
See Also:
  - Snappy framing format description

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FramedSnappyCompressorInputStream(InputStream in)`
  Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream using the `FramedSnappyDialect.STANDARD` dialect.
  `FramedSnappyCompressorInputStream(InputStream in, int blockSize, FramedSnappyDialect dialect)`
  Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream.
  `FramedSnappyCompressorInputStream(InputStream in, FramedSnappyDialect dialect)`
  Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  `void`
  `close()`
  `long`
  `getCompressedCount()`
  Gets the amount of raw or compressed bytes read by the stream.
  `static boolean`
  `matches(byte[] signature, int length)`
  Checks if the signature matches what is expected for a .sz file.
  `int`
  `read()`
  `int`
  `read(byte[] b, int off, int len)`

  ### Methods inherited from class org.apache.commons.compress.compressors.CompressorInputStream

  `count, count, getBytesRead, getCount, getUncompressedCount, pushedBackBytes`

  ### Methods inherited from class java.io.InputStream

  `mark, markSupported, read, reset, skip`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.compress.utils.InputStreamStatistics

  `getUncompressedCount`

- ## Constructor Details

  - ### FramedSnappyCompressorInputStream

    public FramedSnappyCompressorInputStream(InputStream in) throws IOException
    Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream using the `FramedSnappyDialect.STANDARD` dialect.
    Parameters:
      `in` - the InputStream from which to read the compressed data
    Throws:
      `IOException` - if reading fails

  - ### FramedSnappyCompressorInputStream

    public FramedSnappyCompressorInputStream(InputStream in, FramedSnappyDialect dialect) throws IOException
    Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream.
    Parameters:
      `in` - the InputStream from which to read the compressed data
      `dialect` - the dialect used by the compressed stream
    Throws:
      `IOException` - if reading fails

  - ### FramedSnappyCompressorInputStream

    public FramedSnappyCompressorInputStream(InputStream in, int blockSize, FramedSnappyDialect dialect) throws IOException
    Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream.
    Parameters:
      `in` - the InputStream from which to read the compressed data
      `blockSize` - the block size to use for the compressed stream
      `dialect` - the dialect used by the compressed stream
    Throws:
      `IOException` - if reading fails
      `IllegalArgumentException` - if blockSize is not bigger than 0
    Since:
      1.14

- ## Method Details

  - ### matches

    public static boolean matches(byte[] signature, int length)
    Checks if the signature matches what is expected for a .sz file.

    .sz files start with a chunk with tag 0xff and content sNaPpY.

    Parameters:
      `signature` - the bytes to check
      `length` - the number of bytes to check
    Returns:
      true if this is a .sz stream, false otherwise

  - ### available

    public int available() throws IOException
    Overrides:
      `available` in class `InputStream`
    Throws:
      `IOException`

  - ### close

    public void close() throws IOException
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `InputStream`
    Throws:
      `IOException`

  - ### getCompressedCount

    public long getCompressedCount()
    Description copied from interface: `InputStreamStatistics`
    Gets the amount of raw or compressed bytes read by the stream.
    Specified by:
      `getCompressedCount` in interface `InputStreamStatistics`
    Returns:
      the amount of raw or compressed bytes read by the stream.
    Since:
      1.17

  - ### read

    public int read() throws IOException
    Specified by:
      `read` in class `InputStream`
    Throws:
      `IOException`

  - ### read

    public int read(byte[] b, int off, int len) throws IOException
    Overrides:
      `read` in class `InputStream`
    Throws:
      `IOException`